<?php
/*
Plugin Name: Bloglines Blogroll
Plugin URI: http://www.digitalramble.com/bloglinesblogroll-wordpress-plugin/
Description: Uses your bloglines account to create a blogroll in your sidebar.
Author: Cindy Moore
Author URI: http://digitalramble.com
Version: 1.1
Disclaimer: Use at your own risk. No warranty expressed or implied is provided.
*/

/*
	Note: for this to work,  you must have a Bloglines account 
	(or else be interested in displaying a public account you like), 
	which is open to sharing, and has some public subscriptions.  
	Read up at bloglines if you're not sure what I'm 
	talking about: http://www.bloglines.com/help/share

	You  must pass in a title and your blogline username, and you 
	can optionally also pass in a folder and a target.

	More information on setup is available here:
	http://www.digitalramble.com/bloglinesblogroll-wordpress-plugin/

	Note that this uses CURL; if you do not have this, there is 
	an alternative call provided in the comments below.  But CURL is 
	safer; use it if you have it.
	
*/

function printBloglinesBlogroll($title, $id, $folder='', $target='') 
{
        $blprefix = 'http://rpc.bloglines.com/blogroll?html=1&id=';
	$blurl = $blprefix.$id;
	if (strlen($folder)>0)
	{
	  $blurl .= '&folder='.$folder;
	}
	if (strlen($target)>0)
	{
	  $blurl .= '&target='.$target;
	}


	$output = '';
	
	$output .= "<ul>\n";
	
	// safely download contents of external url using CURL
	// if no curl support, just replace the next nine lines with this one
	// $lines = file('http://example.com/');
	$ch = curl_init();
	$timeout = 5; // set to zero for no timeout
	curl_setopt ($ch, CURLOPT_URL, $blurl);
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
	$file_contents = curl_exec($ch);
	curl_close($ch);
	// end CURL file() substitute

	list($blogroll, $trash) = split('\<a href\=\"http\:\/\/www.bloglines.com\" style=\"', $file_contents);
	$folders = split('\<p \/\>\<div class\=\"blogrollfolder\"\>', $blogroll);
	$idx = 0;
	$fidx = 0;
	foreach ($folders as $folder) {
		if ($idx > 0) {
			$folder_content = split('\<\/div\>', $folder);
			foreach ($folder_content as $content) {
				if ($fidx == 0) {
					$output .= "</ul><u><b>$content</b></u><ul>";
				} else {
					$items = split('\<div class=\"blogrollitem\"\>', $content);
					foreach ($items as $item) {
						if (strlen(trim($item)) > 0) {
							$output .= '<li>' . $item . '</li>';
						}
					}
				}
				$fidx++;
			}
		}
		
		$idx++;
		$fidx = 0;
	}

	$output .= "</ul>\n";
	echo $output;
	return;
}

?>
